#include <string.h>
#include <stdio.h>

#include "cms_util.h"
#include "cms_log.h"
#include "cms_files.h"

int main(int argc, char** argv)
{
	if (argc < 2)
	{
		fprintf(stderr, "Usage: %s <init|build>\n", argv[0]);
		return 1;
	}

	if (strcmp(argv[1], "init") == 0) //Initiate directory
	{
		if (argc != 3)
		{
			fprintf(stderr, "Usage: %s init <directory>\n", argv[0]);
			return 1;
		}

		char* dirname = argv[2];

		//Get the path of .cmsinited, which tells us
		//whether or not the directory is already inited
		char* initedPath = cms_util_path_join(dirname, CMS_FILE_INITED);
		if (initedPath == NULL)
			cms_log_panic("Memory allocation failed.");

		//Check if the .cmsinited file exists
		if (cms_util_file_exists(initedPath))
			cms_log_error("Directory already initiated.");

		//Create .cmsinited file
		cms_util_file_create(initedPath);
	}

	else if (strcmp(argv[1], "build") == 0) //Build
	{
	}
}
